/* t@CŜMIMEaGR[h                  */
/*                          Copyright(C)1999 by T.Toda */
#include <stdio.h>

#ifdef	MSDOS
#define	OPENMODE	"rb"
#else
#define	OPENMODE	"r"
#endif

#define	LINELEN	57

static	char	b_table[] 
	= "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
static	unsigned char	buffer[3] = {0, 0, 0};
static	int	bufptr = 0;
static	void	putb64(int), endb64(void);

int	main(int argc, char **argv, char **envp)
{
	FILE	*fp;
	int	c, len;

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs(" [infile]\n", stderr);
		return	4;
	}
	if( argc != 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],OPENMODE)) == NULL ){
		fputs("Can't Open '",stderr);
		fputs(argv[1],stderr);
		fputs("'.\n",stderr);
		return	8;
	}

	len = 0;
	while(( c = getc(fp)) != EOF ){
		putb64(c);
		if( ++len >= LINELEN ){
			putchar('\n');
			len = 0;
		}
	}
	endb64();
	putchar('\n');
	return	0;
}

static	void	putb64(int c)
{
	int	i;

	buffer[bufptr++] = c;
	if( bufptr >= 3 ){
		putchar(b_table[ ( buffer[0] >> 2 ) & 0x3f ]);
		putchar(b_table[ (( buffer[0] << 4 ) 
		              | ( buffer[1] >> 4 )) & 0x3f ]);
		putchar(b_table[ (( buffer[1] << 2 ) 
		              | ( buffer[2] >> 6 )) & 0x3f ]);
		putchar(b_table[ buffer[2] & 0x3f ]);
		for( i = 0 ; i < 3 ; i++ ){
			buffer[i] = 0;
		}
		bufptr = 0;
	}
}

static	void	endb64()
{
	int	i;

	if( bufptr > 0 ){
		putchar(b_table[  ( buffer[0] >> 2 )  & 0x3f ]);
		putchar(b_table[ (( buffer[0] << 4 ) 
		                | ( buffer[1] >> 4 )) & 0x3f ]);
		putchar( bufptr == 1 ? '=' : 
		        b_table[ (( buffer[1] << 2 ) 
		                | ( buffer[2] >> 6 )) & 0x3f ]);
		putchar('=');
		for( i = 0 ; i < 3 ; i++ ){
			buffer[i] = 0;
		}
		bufptr = 0;
	}
}
