/* Convert Decimal Code in HTML Format */
/*           Copyright 2001 (c) T.Toda */
#include <stdio.h>

#define	MAX	6

int	main(int argc, char **argv, char **envp)
{
	int	c, iptr, done, i;
	unsigned int	iresult, hex;
	int	buffer[MAX];
	FILE	*fp;

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs("[orgfile]\n", stderr);
		return	4;
	}

	if( argc != 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],"r")) == NULL ){
		fputs("File Open Error.\n",stderr);
		return	8;
	}

	while(( c = getc(fp) ) != EOF ){
		if( c != '&' ){
			putchar(c);
			continue;
		}
		c = getc(fp);
		if( c != '#' ){
			putchar('&');
			putchar(c);
			continue;
		}
		iresult = 0;
		done = 0;
		hex = 10;
		for( iptr = 0 ; iptr < MAX ; iptr++ ){
			buffer[iptr] = getc(fp);
			if( buffer[iptr] == ';' ){
				/* put into UTF-8 */
				if( iresult <= 0x7f ){
					putchar((signed)iresult);
				}
				else if( iresult <= 0x7ff ){
					putchar( (signed)(0xc0 | ( iresult >> 6 )) );
					putchar( (signed)(0x80 | ( iresult & 0x3f )) );
				}
				else{
					putchar( (signed)(0xe0 | ( iresult >> 12 )) );
					putchar( (signed)(0x80 | ( ( iresult >> 6 ) & 0x3f )) );
					putchar( (signed)(0x80 | ( iresult & 0x3f )) );
				}
				done = 1;
				break;
			}
			else if( ((buffer[iptr] == 'x')
			       || (buffer[iptr] == 'X'))
			       && (iptr == 0) ){
				hex = 16;
			}
			else if( (buffer[iptr] >= '0')
			      && (buffer[iptr] <= '9') ){
				iresult *= hex;
				iresult += buffer[iptr] - '0';
			}
			else if( (buffer[iptr] >= 'A')
			      && (buffer[iptr] <= 'F')
			      && (hex == 16) ){
				iresult *= hex;
				iresult += buffer[iptr] - 'A' + 10;
			}
			else if( (buffer[iptr] >= 'a')
			      && (buffer[iptr] <= 'f')
			      && (hex == 16) ){
				iresult *= hex;
				iresult += buffer[iptr] - 'a' + 10;
			}
			else{
				iptr++;
				break;
			}
		}
		if( done == 0 ){
			putchar('&');
			putchar('#');
			for( i = 0 ; i < iptr ; i++ ){
				putchar( buffer[i] );
			}
		}
	}
	return	0;
}
