/* Read MIME-encoded SJIS message which has been converted to Latin-1 */
/* by MIME-encoder on Macintosh       Copyright(c)1997,2001 by T.Toda */
#include <stdio.h>

static	unsigned char	table[] = {
	0xa5, 0xaa, 0xad, 0xb0, 0xb3, 0xb7, 0xba, 0xbd,
	0xc3, 0xc5, 0xc9, 0xd1, 0xd4, 0xd9, 0xda, 0xb6,
	0xc6, 0xce, 0xe2, 0xe3, 0xe4, 0xf0, 0xf6, 0xf7,
	0xf9, 0xfa, 0xfb, 0xfd, 0xfe, 0xff, 0xf5, 0xc4,
	0xca, 0xc1, 0xa2, 0xa3, 0xdb, 0xb4, 0xcf, 0xa4,
	0xac, 0xa9, 0xbb, 0xc7, 0xc2, 0xd0, 0xa8, 0xf8,
	0xa1, 0xb1, 0xd3, 0xd2, 0xab, 0xb5, 0xa6, 0xe1,
	0xfc, 0xd5, 0xbc, 0xc8, 0xb9, 0xb8, 0xb2, 0xc0,
	0xcb, 0xe7, 0xe5, 0xcc, 0x80, 0x81, 0xae, 0x82,
	0xe9, 0x83, 0xe6, 0xe8, 0xed, 0xea, 0xeb, 0xec,
	0xdc, 0x84, 0xf1, 0xee, 0xef, 0xcd, 0x85, 0xd7,
	0xaf, 0xf4, 0xf2, 0xf3, 0x86, 0xa0, 0xde, 0xa7,
	0x88, 0x87, 0x89, 0x8b, 0x8a, 0x8c, 0xbe, 0x8d,
	0x8f, 0x8e, 0x90, 0x91, 0x93, 0x92, 0x94, 0x95,
	0xdd, 0x96, 0x98, 0x97, 0x99, 0x9b, 0x9a, 0xd6,
	0xbf, 0x9d, 0x9c, 0x9e, 0x9f, 0xe0, 0xdf, 0xd8};

int	main(int argc, char **argv, char **envp)
{
	int	c, c1;
	FILE	*fp;

	if( argc > 2 ){
		fputs("Usage : ", stderr);
		fputs(argv[0], stderr);
		fputs("[macfile]\n", stderr);
		return	4;
	}

	if( argc != 2 ){
		fp = stdin;
	}
	else if(( fp = fopen(argv[1],"r")) == NULL ){
		fputs("File Open Error.\n",stderr);
		return	8;
	}

	while(( c = getc(fp) ) != EOF ){
		if( c != '=' ){
			putchar(c);
		}
		else{
			c1 = getc(fp);
			if( c1 >= '0' && c1 <= '9' ){
				c = c1 - '0';
			}
			else if( c1 >= 'A' && c1 <= 'F' ){
				c = c1 - 'A' + 10;
			}
			else if( c1 == '\n' ){
				continue;
			}
			else{
				putchar(c1);
				continue;
			}
			c1 = getc(fp);
			if( c1 >= '0' && c1 <= '9' ){
				c *= 16;
				c += c1 - '0';
			}
			else if( c1 >= 'A' && c1 <= 'F' ){
				c *= 16;
				c += c1 - 'A' + 10;
			}
			else{
				putchar(c);
				putchar(c1);
				continue;
			}
			if( c < 0x80 ){
				putchar(c);
				continue;
			}
			c1 = c - 0x80;
			putchar( c1 > sizeof(table) || table[c1] == 0 ? c : table[c1] );
			c1 = 0;
		}
	}
	return	0;
}
